<?php 
  try {
    function getField($arr, $f) {
       if (isset($arr[$f]) && $arr[$f]) return $arr[$f];
       else return "";
    }

   function printHeader() {
   echo("<!DOCTYPE html \n");
   echo("     PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\"\n");
   echo("         \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n");
   echo("<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\" lang=\"en\">\n");
   echo("<head>\n");
   echo("   <title>Faculty Applications</title>\n");
   echo("   <meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" />\n");
   echo("   <meta http-equiv=\"Content-Language\" content=\"en\" />\n");
   echo("<style type=\"text/css\" media=\"screen\">\n");
   echo("a:link { color:inherit;  }\n");
   echo("a:visited { color:inherit;  }\n");
   echo("a:hover { color:inherit;  }\n");
   echo("a:active { color:inherit;  }\n");
   echo("</style>\n");
   echo("<script>\n");
   echo("   var timer;\n");
   echo("</script>\n");
   echo("</head>\n");
   $hash = getField($_REQUEST, "hash");
   echo("<body".($hash ? " onload=\"document.location.hash = ('".$hash."')\"" : "").">\n");
   }

   function errHandle($errNo, $errStr, $errFile, $errLine) {
       $msg = "$errStr in $errFile on line $errLine";
       if (/*$errNo == E_NOTICE ||*/ $errNo == E_WARNING) {
           throw new ErrorException($msg, $errNo);
       } else {
          //echo $msg;
       }
    }

    set_error_handler('errHandle');

    session_start();

    $sep = ".";

     if(getField($_GET, "key")) {
        $authenticated = "";
     } else {
        $authenticated = $_SESSION["user"];
        $user_id = $_GET["user"];
        if($authenticated && $user_id && $authenticated != $user_id) {
           $authenticated = "";
        }
        if(!$user_id) $user_id = $_SESSION["user"];
     }

     $num_levels = $_GET["num_levels"];
     $level_info = array();
     for($i = 0; $i < $num_levels; $i++) {
         $str = $_GET["level-".$i];
         $a = explode($sep, $str);
         $level_info[$i] = ["field"=>$a[0],"desc"=>$a[1],"inv"=>$a[2]];
     }

     if(!$num_levels) {
        $num_levels = 1; // 2
        $level_info[0] = ["field"=>"review_date","desc"=>0];
        //$level_info[1] = ["field"=>"name","desc"=>0];
     }

     // connect to localhost
     $link = mysql_connect('localhost', 'mcclurgv_school', 'Noquar9school');
     if (!$link) throw new Exception('Could not connect: ' . mysql_error()); // TODO remove the mysql message

     // select the faculty_apps database
     $db_selected = mysql_select_db('mcclurgv_faculty_apps', $link);
     if (!$db_selected) throw new Exception('Can\'t use faculty_apps database: ' . mysql_error()); // TODO remove the mysql message

     $user_result = mysql_query("SELECT * FROM users ORDER BY id");
     if(!$user_result) throw new Exception("Can't do select: ".mysql_error()); // TODO remove the mysql message

     $user_info = array();
     $num_user_result = mysql_num_rows($user_result);
     $found_user = false;
     for($i = 0; $i < $num_user_result; $i++) {
       $row = mysql_fetch_assoc($user_result);
       $user_info[] = $row;
       $id = $row['id'];

       if(!$found_user) {
          if(!$authenticated) {
             if(($_REQUEST["email"] == $row['email'] || $_REQUEST["user"] == $id) && $_REQUEST["key"] == $row['key']) {
                $authenticated = true;
                $user_email = $_REQUEST["email"];
                $user_key = $_REQUEST["key"];
                $user_id = $id;
                $_SESSION["user"] = $user_id;
             } else {
                continue;
             }
          }
            $user_name = $row['name'];
            $user_email = $row['email'];
            $user_is_writer = $row['letter_writer'];

            if($id == $user_id) {
                $found_user = true;
            }
         }
     }

     // check if authenticated
     if(!$found_user) throw new Exception("Can't log in as user ID ".$user_id.". Please click on the link you received via email!");

     if(getField($_GET, "key")) {
         header("Location: ".basename(__FILE__)."?user=".$user_id);
         die();
     }

     printHeader();

     $names = explode(" ", $user_name);
     echo("<h1>Hello, ".$names[0]."!</h1>");

     if(!$user_is_writer) {
        echo("<table border=\"1\">\n");
        foreach($user_info as $r) {
           $id = $r["id"];
           $email = $r["email"];
           $key = $r["key"];
           echo("<tr><td>".$email."</td><td>http://www.jrmcclurg.com/".basename(__FILE__)."?user=".$id."&key=".$key."</td></tr>");
        }
        echo("</table>\n");
     }

     function loadLetters($user_id) {
        $letters_result = mysql_query("SELECT * FROM letters WHERE user='".$user_id."'");
        if(!$letters_result) throw new Exception("Can't do select: ".mysql_error()); // TODO remove the mysql message

        $letters = array();
        $num_letters = mysql_num_rows($letters_result);
        for($i = 0; $i < $num_letters; $i++) {
           $letters[] = mysql_fetch_assoc($letters_result);
        }
        
        $letter_info = array();
        for($i = 0; $i < $num_letters; $i++) {
           $letter = $letters[$i];
           $letter_id = $letter["id"];
           $letter_author_id = $letter["user"];
           $letter_inst = $letter["institution"];
           $letter_submitted = $letter["submitted"];
           $letter_comment = $letter["comment"];
           $letter_time = $letter["time"];

           if($letter_author_id == $user_id) {
              $letter_info[$letter_inst] = ["id"=>$letter_id,"time"=>$letter_time,"submitted"=>$letter_submitted,"comment"=>$letter_comment];
           }
        }

        return $letter_info;
     }

     $letter_info = loadLetters($user_id);

     //$result = mysql_query("SELECT * FROM invitations WHERE code='".$code."'");
     $sortby2 = "";
     foreach($level_info as $i => $r) {
        $field = $r["field"];
        $desc = $r["desc"];
        $inv = $r["inv"];
        $str_d = "DESC";
        $str_a = "ASC";
        /*if($inv) {
           $temp = $str_a;
           $str_a = $str_d;
           $str_d = $temp;
        }*/
        if($field) $sortby2 = $sortby2.(($sortby2) ? ", " : "")." ".($inv ? ("ISNULL(".$field.")".($desc ? " ASC" : " ASC").", ") : "").$field." ".(($desc) ? $str_d : $str_a);
     }
     if($sortby2) $sortby2 = "ORDER BY".$sortby2;
     $result = mysql_query("SELECT * FROM institutions ".$sortby2);
     if(!$result) throw new Exception("Can't do select: ".mysql_error()); // TODO remove the mysql message

     $insts = array();
     $num_insts = mysql_num_rows($result);
     for($i = 0; $i < $num_insts; $i++) {
       $row = mysql_fetch_assoc($result);
       $id = $row['id'];
       /*$name = $row['name'];
       $loc = $row['location'];
       $dept = $row['dept'];
       $visible = $row['visible'];

       $insts[$id] = ["name"=>$name,"location"=>$loc,"dept"=>$dept,"visible"=>$visible];*/
       $insts[$id] = $row;
     }

     if($_POST) {
        $updated = false;
        foreach($insts as $id => $row) {
           $newSubmitted = (getField($_POST, "submitted-".$id)) ? 1 : 0;
           $newComment = $_POST["comment-".$id];
           $info = getField($letter_info, $id);

           if(!$info) {
              if($newSubmitted || $newComment) {
                 // add a new reference letter to the table
                 $result = mysql_query("INSERT INTO letters (user,institution,submitted,comment) VALUES ('".$user_id."', '".$id."', '".$newSubmitted."', '".mysql_real_escape_string($newComment)."')");
                 if(!$result) throw new Exception("Can't do insert: ".mysql_error()); // TODO remove the mysql message
                 else $updated = true;
              }
           } else {
              // update the reference letter already in the table
              $letter_id = $info["id"];
              $letter_submitted = $info["submitted"];
              $letter_comment = $info["comment"];

              if($letter_submitted != $newSubmitted || $letter_comment != $newComment) {
                 $result = mysql_query("UPDATE letters SET submitted='".$newSubmitted."', comment='".mysql_real_escape_string($newComment)."' WHERE id='".$letter_id."'");
                 if(!$result) throw new Exception("Can't do update: ".mysql_error()); // TODO remove the mysql message
                 else $updated = true;
              }
           }
        }

        if($updated) $letter_info = loadLetters($user_id);
     }



     $sorts = array(
        ""=>[""],
        "name"=>["Institution Name"],
        "location"=>["Geographical Location"],
        "dept"=>["Department"],
        "rank_usn_lib"=>["US News Liberal Arts rank",true],
        "rank_usn_cs"=>["US News CS Graduate School rank",true],
        "job_area"=>["Area"],
        "applied"=>["Application Sent"],
        "review_date"=>["Review Date"]
     );
     $num_sorts = count($sorts);

     // document.getElementById("sortForm").appendChild(document.getElementById("sortForm").elements[0].cloneNode(true))
     // document.getElementById("sortForm").elements[0]

     echo("<form id=\"sortForm\" method=\"get\" action=\"".basename(__FILE__)."\">\n");
     echo("<input type=\"hidden\" value=\"".$user_id."\" name=\"user\" />\n");
     echo("<input type=\"hidden\" value=\"".$num_levels."\" name=\"num_levels\" />\n");
     echo("<input type=\"submit\" value=\"Sort by\" onclick=\"\" />\n");
     echo("<input type=\"button\" value=\"+\" title=\"One more field to sort by\" onclick=\"javascript:var form = document.getElementById('sortForm'); var x = form.lastChild.cloneNode(true); var num = parseInt(form.num_levels.value); x.name = 'level-'+num; form.num_levels.value = (num+1); form.appendChild(x);\" />\n");
     echo("<input type=\"button\" value=\"-\" title=\"One less field to sort by\" onclick=\"javascript:var form = document.getElementById('sortForm'); var num = parseInt(form.num_levels.value); if(num > 1) { document.getElementById('sortForm').num_levels.value = (num-1); form.removeChild(form.lastChild);}\" />\n");
     for($i = 0; $i < $num_levels; $i++) {
        echo("<select name=\"level-".$i."\">");
        foreach($sorts as $sort => $d) {
           //echo(" <a href=\"?user=".$user_id."&sortby=".$sort."&sortby-desc=".!$sortby_desc."\">".$descrip."</a>");
           $descrip = $d[0];
           $sel = ($level_info[$i]["field"] == $sort);
           $desc = $level_info[$i]["desc"];
           $inv = $d[1];
           if($descrip) {
              echo("<option value=\"".$sort.$sep."0.".$inv."\"".(($sel && !$desc) ? " selected=\"selected\"" : "").">".$descrip." (A-Z)</option>");
              echo("<option value=\"".$sort.$sep."1.".$inv."\"".(($sel && $desc) ? " selected=\"selected\"" : "").">".$descrip." (Z-A)</option>");
           } else {
              echo("<option value=\"".$sort."\"".(($sel) ? " selected=\"selected\"" : "")."></option>");
           }
        }
        echo("</select>");
     }
     echo("</form>\n");

     echo("<hr />");

     echo("<p>Please mark which letters you have sent, and press <b>Save</b> (you can also save the form by <i>clicking in the table rows</i>). You can return to this form via your email link at any time.</p>\n");
     echo("<form id=\"instForm\" method=\"post\" action=\"".htmlentities($_SERVER['REQUEST_URI'])."\">\n");
     echo("<input id=\"hashField\" type=\"hidden\" value=\"\" name=\"hash\" />\n");
     echo("<input type=\"submit\" value=\"Save\" title=\"Save any edits\" />\n");
     echo("<input type=\"reset\" value=\"Cancel\" title=\"Discard any edits\" />\n");
     echo("<table border=\"0\" cellpadding=\"8\" cellspacing=\"0\" width=\"100%\">\n");
     echo("<tr><td></td>\n");
     echo("<td><i>Institution</i></td>\n");
     echo("<td><i>Location</i></td>\n");
     echo("<td><i>Type</i></td>\n");
     echo("<td><i>Dept</i></td>\n");
     echo("<td><i>Area</i></td>\n");
     echo("<td><i>Applied?</i></td>\n");
     echo("<td><i>Review Date</i></td>\n");
     echo("<td><i>Days Left</i></td>\n");
     echo("<td><i>Letter Sent?</i></td>\n");
     echo("<td><i>Comments</i></td>\n");
     echo("</tr>\n");

     $i = 0;
     $flag = true;
     foreach($insts as $id => $row) {
       $name = $row['name'];
       $loc = $row['location'];
       $lib_rank = $row['rank_usn_lib'];
       $cs_rank = $row['rank_usn_cs'];
       $type = (($lib_rank) ? "liberal arts, rank ".$lib_rank : (($cs_rank) ? "research university, rank ".$cs_rank : "unranked"));
       $dept = $row['dept'];
       $url_ad = $row['job_url'];
       $area = $row['job_area'];
       $applied = $row['applied'];
       $review_date = strtotime($row['review_date']);
       $days = floor(($review_date - time()) / (60 * 60 * 24));
       $notes = $row['notes'];
       // TODO XXX - remember to do the event.stopPropagation() in any links in the notes!
       $url_letter = $row['letter_url'];
       $visible = $row['visible'];

       if(!$url_letter) $url_letter = "Letter submission link: TBA";
       // TODO XXX - remember to do the event.stopPropagation() in any letter submission links!

       if($visible) {
          $onclickCode = "document.getElementById('hashField').value = 'row'+".($i+1).";";
          // window.getSelection().toString().length > 0
          $submitCode = "onchange=\"".$onclickCode." timer = setTimeout(function () {if(window.getSelection().toString().length === 0) document.getElementById('instForm').submit()}, 1000);\"";
          $bg = ($flag) ? "#ececec" : "white";
          $fg = ($flag) ? "dimgray" : "gray";
          echo("<tr id=\"row".($i+1)."\" style=\"background:".$bg."\">\n");
          echo("<td>".($i+1)."</td>\n");
          echo("<td><b>".$name."</b></td>\n");
          echo("<td><a href=\"http://maps.google.com/?q=".$name." ".$loc."\">".$loc."</a></td>\n");
          echo("<td>".$type."</td>\n");
          echo("<td>".htmlentities($dept)."</td>\n");
          echo("<td>".str_replace(",", ", ", $area)."</td>\n");
          echo("<td>".(($applied) ? "<b>yes</b>" : "no")."</td>\n");
          echo("<td><b>".(($review_date > 0) ? date("M j, Y",$review_date) : "")."</b></td>\n");
          echo("<td>".(($review_date > 0) ? $days : "")."</td>\n");
          if($user_is_writer) {
             $info = getField($letter_info, $id);
             $submitted = getField($info, "submitted");
             $comment = getField($info, "comment");
             echo("<td><input type=\"checkbox\" ".$submitCode." onclick=\"clearTimeout(timer)\" name=\"submitted-".$id."\"".(($submitted) ? " checked=\"checked\"" : "")." /></td>\n");
             echo("<td><input type=\"text\" ".$submitCode." onclick=\"clearTimeout(timer)\" name=\"comment-".$id."\" value=\"".$comment."\" /></td>\n");
          }
          echo("</tr>\n");
          echo("<tr style=\"background:".$bg."\">\n");
          echo("<td></td><td colspan=\"5\" style=\"color:".$fg."\">".$notes."</td><td style=\"color:".$fg."\"><a onclick=\"event.stopPropagation();\" href=\"".htmlentities($url_ad)."\">Job Ad</a></td><td colspan=\"4\" style=\"color:".$fg."\">".htmlentities($url_letter)."</td>\n");
          echo("</tr>\n");

          $flag = !$flag;

          $i++;
       }
     }

     echo("</table>\n");
     echo("<input onclick=\"".$onclickCode."\" type=\"submit\" value=\"Save\" title=\"Save any edits\" />\n");
     echo("<input type=\"reset\" value=\"Cancel\" title=\"Discard any edits\" />\n");
     echo("</form>\n");
  } catch(Exception $e) {
     printHeader();
     echo $e->getMessage();
  }

  if($link) {
     //echo("Closed MySQL link");
     mysql_close($link);
  }
?>
</body>
</html>
