<script type="text/javascript">
//<![CDATA[
var myAudio = new Audio("https://www.facebook.com/tts/?flavor=pronouncer&text=[%23d_ZE.dI%22daI_%5E.%40%23]%20[%23m%40%22kl3%3A%60g%23]&id=14820822&format=mp3")
//]]>
</script>
<!--<audio id="audio1" src="https://www.facebook.com/tts/?flavor=echo&text=[%23d_ZE.dI%22daI_%5E.%40%23]%20[%23%22m%40.kl3%3A%60g%23]&id=14820822&format=mp3" preload="auto"></audio>-->
<table width="100%" border="0"><tr><td>
<img src="../bw_small.jpg" width="225" align="left" alt="Photo" />
<h3>Basic Info</h3>
Jedidiah McClurg<sup><a href="#pronunciation">1</a></sup><br />
Ph.D. Candidate, <a href="http://pl.cs.colorado.edu/">CUPLV Group</a><br />
Department of Computer Science<br />
University of Colorado Boulder<p />

Contact: <a href="mailto:jed@jrmcclurg.com">jed@jrmcclurg.com</a><br />
Office: <a href="http://www.colorado.edu/cs/about/directions">ECEE 1B61A</a><p />

Academic CV: <b><a href="http://www.jrmcclurg.com/cv.pdf">cv.pdf</a></b> | <a href="http://scholar.google.com/citations?user=SVuYyQ4AAAAJ">Google Scholar</a> | <a href="http://dblp.uni-trier.de/pers/hd/m/McClurg:Jedidiah">DBLP</a><p />

Other sites: <a href="https://www.linkedin.com/in/jrmcclurg">LinkedIn</a> |
<a href="https://github.com/jrmcclurg">GitHub</a> | 
<a href="https://bitbucket.org/jrmcclurg">BitBucket</a> |
<a href="http://stackoverflow.com/users/1613162/808sound">StackOverflow</a> |
<a href="http://askubuntu.com/users/83597/808sound">AskUbuntu</a>
</td></tr></table>
<!--<img alt="University of Iowa logo" src="/uiowa.gif" /><br /><br />-->
<h3>Research Interests</h3>
Programming Languages, Verification, Synthesis, Software-Defined Networking (SDN)
<h3>Education</h3>
<ul>
<li>Ph.D. Computer Science, University of Colorado Boulder, 2018 (expected)
 <ul><li>Advisor: <a href="http://ecee.colorado.edu/pavol/">Pavol Cerny</a></li></ul>
</li>
<li>M.S. Computer Science, Northwestern University, 2013</li>
<li>B.S. Electrical Engineering, University of Iowa, 2009</li>
</ul>


<!--<a href="http://stackexchange.com/users/1753057">
<img src="http://stackexchange.com/users/flair/1753057.png" width="208" height="58" alt="profile for 808sound on Stack Exchange, a network of free, community-driven Q&amp;A sites" title="profile for 808sound on Stack Exchange, a network of free, community-driven Q&amp;A sites"
</a>-->

<h3>Internships</h3>
<ul>
   <li><a href="http://research.microsoft.com/en-us/">Microsoft Research</a>, <a href="http://research.microsoft.com/en-us/groups/rise/">RiSE Group</a>, Redmond WA (2014)
</li>
   <li>Rockwell Collins, Advanced Technology Center, Cedar Rapids IA (2011, 2013)</li>
</ul>

<!--<h3>Papers in Preparation</h3>
<ul>
   <li>Jedidiah McClurg, <i>Parser Generator Generator (PGG): a Tool for Rapid Parser Construction via EBNF Grammars</i>, EECS Technical Report NU-EECS-12-04, 2012</li>
</ul>-->
<!--<h3>Papers in Submission</h3>
<table>
   <tr><td>[8]</td><td width="80%"><i><a href="http://arxiv.org/pdf/1507.07049v2.pdf">Event-driven Network Programming</a></i></td><td width="20%"></td></tr>
   <tr><td></td><td>Jedidiah McClurg, Hossein Hojjat, Nate Foster, Pavol Cerny</td><td rowspan="2"></td></tr>
</table>-->
<h3>Conference Papers</h3>
<table>
   <tr><td valign="top">[11]</td><td width="80%"><i><a href="http://www.jrmcclurg.com/papers/cav_2017_paper.pdf">Synchronization Synthesis for Network Programs</a></i></td><td width="20%" rowspan="3" valign="top">(<b><a href="http://www.cavconference.org/2017/">CAV 2017</a></b>)<p style="margin: 3px 0 0 0" /><small>57 / 191 = 30%</small><p style="margin: 0 0 0 0" /><a href="http://www.cavconference.org/2017/cav-2017-call-for-papers/"><img src="../cav-aec.png" width="24" height="24" title="artifact &ldquo;met or exceeded expectations&rdquo;" alt="AEC badge" /></a></td></tr>
   <tr><td></td><td>Jedidiah McClurg, Hossein Hojjat, Pavol Cerny</td></tr>
   <tr><td></td><td>29th Intl. Conf. on Computer-Aided Verification</td></tr>
   <tr><td></td></tr>

   <tr><td valign="top">[10]</td><td width="80%"><i><a href="http://www.jrmcclurg.com/papers/fmcad_2016_paper.pdf">Optimizing Horn Solvers for Network Repair</a></i></td><td width="20%" rowspan="3" valign="top">(<b><a href="http://www.cs.utexas.edu/users/hunt/FMCAD/FMCAD16/">FMCAD 2016</a></b>)<p style="margin: 3px 0 0 0" /><small>23 / 64 = 36%</small></td></tr>
   <tr><td></td><td>Hossein Hojjat, Philipp Ruemmer, Jedidiah McClurg, Pavol Cerny, Nate Foster</td></tr>
   <tr><td></td><td>16th Intl. Conf. on Formal Methods in Computer-Aided Design</td></tr>
   <tr><td></td></tr>

   <tr><td valign="top">[9]</td><td width="80%"><i><a href="http://www.jrmcclurg.com/papers/disc_2016_paper.pdf">Optimal Consistent Network Updates in Polynomial Time</a></i><br />(<a href="http://arxiv.org/pdf/1607.05159">extended version</a>)</td><td width="20%" rowspan="3" valign="top">(<b><a href="http://www.disc-conference.org/wp/disc2016/">DISC 2016</a></b>)<p style="margin: 3px 0 0 0" /><small>32 / 132 = 24%</small></td></tr>
   <tr><td></td><td>Pavol Cerny, Nate Foster, Nilesh Jagnik, Jedidiah McClurg</td></tr>
   <tr><td></td><td>30th International Symposium on Distributed Computing</td></tr>
   <tr><td></td></tr>

   <tr><td valign="top">[8]</td><td width="80%"><i><a href="http://www.jrmcclurg.com/papers/pldi_2016_paper.pdf">Event-Driven Network Programming</a></i></td><td width="20%" rowspan="3" valign="top">(<b><a href="http://conf.researchr.org/home/pldi-2016">PLDI 2016</a></b>)<p style="margin: 3px 0 0 0" /><small>49 / 304 = 16%</small><p style="margin: 0 0 0 0" /><a href="http://conf.researchr.org/track/pldi-2016/Research+Artifacts"><img src="../pldi-aec.png" width="24" height="24" title="artifact &ldquo;met or exceeded expectations&rdquo;" alt="AEC badge" /></a></td></tr>
   <tr><td></td><td>Jedidiah McClurg, Hossein Hojjat, Nate Foster, Pavol Cerny</td></tr>
   <tr><td></td><td>37th ACM SIGPLAN Conference on PL Design and Implementation</td></tr>
   <tr><td></td></tr>

   <tr><td valign="top">[7]</td><td width="80%"><i><a href="http://www.jrmcclurg.com/papers/securecomm_2015_paper.pdf">Uranine: Real-time Privacy Leakage Monitoring without System Modification for Android</a></i></td><td width="20%" rowspan="3" valign="top">(<b><a href="http://securecomm.org/2015">SecureComm 2015</a></b>)<p style="margin: 3px 0 0 0" /><small>29 / 107 = 27%</small></td></tr>
   <tr><td></td><td>Vaibhav Rastogi, Zhengyang Qu, Jedidiah McClurg, Yinzhi Cao, Yan Chen</td></tr>
   <tr><td></td><td>11th EAI Intl. Conf. on Security and Privacy in Comm. Networks</td></tr>
   <tr><td></td></tr>

   <tr><td>[6]</td><td width="80%"><i><a href="http://www.jrmcclurg.com/papers/pldi_2015_paper.pdf">Efficient Synthesis of Network Updates</a></i></td><td width="20%" rowspan="3" valign="top">(<b><a href="http://conf.researchr.org/home/pldi2015">PLDI 2015</a></b>)<p style="margin: 3px 0 0 0" /><small>58 / 303 = 19%</small><p style="margin: 0 0 0 0" /><a href="http://conf.researchr.org/track/pldi2015/PLDI+2015+Artifact+Evaluation"><img src="../pldi-aec.png" width="24" height="24" title="artifact &ldquo;met or exceeded expectations&rdquo;" alt="AEC badge" /></a></td></tr>
   <tr><td></td><td>Jedidiah McClurg, Hossein Hojjat, Pavol Cerny, Nate Foster</td></tr>
   <tr><td></td><td>36th ACM SIGPLAN Conference on PL Design and Implementation</td></tr>
</table>
<h3>Workshop/Demo Papers</h3>
<table>
   <tr><td valign="top">[5]</td><td width="80%"><i><a href="http://www.jrmcclurg.com/papers/mobiledeli_2015_paper.pdf">Implementing Real-time Collaboration in TouchDevelop using AST Merges</a></i></td><td width="20%" valign="top">(<b><a href="http://sysrun.haifa.il.ibm.com/hrl/mobiledeli2015/">MobileDeLi 2015</a></b>)</td></tr>
   <tr><td></td><td>Jonathan Protzenko, Sebastian Burckhardt, Michal Moskal, Jedidiah McClurg</td><td></td></tr>
   <tr><td></td><td>3rd International Workshop on Mobile Development Lifecycle</td><td></td></tr>
   <tr><td></td></tr>

   <tr><td valign="top">[4]</td><td width="80%"><i><a href="http://www.jrmcclurg.com/papers/plvnet_2015_paper.pdf">Network Updates for the Impatient: Eliminating Unneccessary Waits</a></i></td><td width="20%" valign="top">(<b><a href="http://ecee.colorado.edu/pavol/plvnet2015/">PLVNET 2015</a></b>)</td></tr>
   <tr><td></td><td>Hossein Hojjat, Jedidiah McClurg, Pavol Cerny, Nate Foster</td><td></td></tr>
   <tr><td></td><td>1st Workshop on PL and Verification Technology for Networking</td><td></td></tr>
   <tr><td></td></tr>

   <tr><td valign="top">[3]</td><td width="80%"><i><a href="http://www.jrmcclurg.com/papers/acl2_2014_paper.pdf">Development of a Translator from LLVM to ACL2</a></i></td><td width="20%" valign="top">(<b><a href="http://vsl2014.at/acl2/">ACL2 2014</a></b>)</td></tr>
   <tr><td></td><td>David Hardin, Jennifer Davis, David Greve, Jedidiah McClurg</td><td></td></tr>
   <tr><td></td><td>11th International Workshop on the ACL2 Theorem Prover</td><td></td></tr>
   <tr><td></td></tr>

   <tr><td valign="top">[2]</td><td width="80%"><i><a href="http://www.jrmcclurg.com/papers/law_2013_paper.pdf">Creating Formally Verified Components for Layered Assurance<br />with an LLVM to ACL2 Translator</a></i></td><td width="20%" valign="top">(<b><a href="https://www.acsac.org/2013/workshops/law/">LAW 2013</a></b>)</td></tr>
   <tr><td></td><td>David Hardin, Jedidiah McClurg, Jennifer Davis</td><td></td></tr>
   <tr><td></td><td>7th Layered Assurance Workshop</td><td></td></tr>
   <tr><td></td></tr>

   <tr><td valign="top">[1]</td><td width="80%"><i><a href="http://www.jrmcclurg.com/papers/sensys_2012_demo.pdf">Collaborative Reactive Behavior in Heterogeneous Wireless<br />Sensor Networks</a></i> (<a href="http://www.jrmcclurg.com/papers/sensys_2012_poster.pdf">poster</a>)</td><td width="20%" valign="top">(<b><a href="http://sensys.acm.org/2012/">SenSys 2012</a></b>)</td></tr>
   <tr><td></td><td>Jedidiah McClurg, Goce Trajcevski, Jesse Yanutola</td><td></td></tr>
   <tr><td></td><td>10th ACM Conference on Embedded Networked Sensor Systems</td><td></td></tr>
   <tr><td></td></tr>
</table>
<!--<h4>Non-refereed Papers</h4>
<ul>
   <li>Jedidiah McClurg, Jonathan Friedman, and William Ng, <i>Android Privacy Leak Detection via Dynamic Taint Analysis</i>, EECS 450 (Internet Security) Final Paper, 2012<br />
   (<a href="http://www.jrmcclurg.com/papers/internet_security_final_report.pdf">paper</a>) (<a href="http://www.jrmcclurg.com/papers/internet_security_final_presentation.pdf">presentation</a>)
   </li>
   <li>Jedidiah McClurg, Kaicheng Zhang, and Yixi Zhang, <i>Virtual Machine Support for Parallel Language Runtimes</i>, EECS 441 (Resource Virtualization) Final Paper, 2012<br />
   (<a href="http://www.jrmcclurg.com/papers/virtualization_final_report.pdf">paper</a>) (<a href="http://www.jrmcclurg.com/papers/virtualization_final_presentation.pdf">presentation</a>)
   </li>
</ul>-->

<h3>Research Talks</h3>
<ul>
   <li><i>Event-Driven Network Programming</i>, PLDI 2016, Portland OR, USA, June 16, 2016</li>
   <li><i>Event-Driven Network Programming</i>, CU Boulder, CUPLV Group, May 27, 2016</li>
   <li><i>Efficient Synthesis of Network Updates</i>, PLDI 2015, Portland OR, USA, June 16, 2015</li>
   <li><i>Efficient Synthesis of Network Updates</i>, CU Boulder, CUPLV Group, June 5, 2015</li>
   <li><i>Efficient Synthesis of Network Updates</i> (with Pavol Cerny), CU Boulder, <a href="https://ngn.cs.colorado.edu/">NGN Group</a>, March 6, 2015</li>
   <li><i>AST-based Collaborative Editing</i>, Microsoft Research, RiSE Group, June 25, 2014</li>
   <li><i><a href="http://www.jrmcclurg.com/papers/virtualization_final_presentation.pdf">Virtual Machine Support for Parallel Language Runtimes</a></i>, Northwestern EECS 441 Class Final Presentation, Evanston IL, USA, May 30, 2012<br/>
   </li>
   <li><i><a href="http://www.jrmcclurg.com/papers/internet_security_final_presentation.pdf">Detecting Android Privacy Leaks via Dynamic Taint Analysis</a></i> (with Jonathan Friedman and William Ng), Northwestern EECS 450 Class Final Presentation, Evanston IL, USA, May 28, 2012<br />
   </li>
   <li><i>Industrial Verification Using the KIND Model Checker</i> (with Lucas Wagner) (<a href="http://www.jrmcclurg.com/papers/afrl_s5_2011_abstract.pdf">abstract</a>), Air Force Research Labs (AFRL) Safe &amp; Secure Systems &amp; Software Symposium (S5), Dayton OH, USA, Jun 14, 2011<br />
   </li>
</ul>
<h3>Service</h3>
<ul>
<li>Artifact Evaluation Committee (AEC) Member, <a href="http://conf.researchr.org/home/POPL-2016">POPL 2016</a></li>
<li>Reviewer, <a href="http://i-cav.org/2014/">CAV 2014</a>, <a href="http://ase2014.org/">ASE 2014</a>, <a href="http://www.etaps.org/2016/tacas">TACAS 2016</a></li>
</ul>
<h3>Miscellaneous</h3>
<ul>
<li><a name="pronunciation"></a>My name is pronounced  <a href="#" onclick="myAudio.play(); return false;">je-di-DY-uh muh-KLURG</a></li>
</ul>
<!--<h4>Overviews of Influential CS Papers</h4>
<ul>
   <li>Jedidiah McClurg, <i>Hey, You, Get Off of My Market: Detecting Malicious Apps in Official and Alternative Android Markets (by Y. Zhou, et al.)</i>, Northwestern EECS 450 Class Lecture, Evanston IL, USA, May 7, 2012<br/>
   (<a href="http://www.jrmcclurg.com/papers/talk_overview_hey_you_get_off_my_market.pdf">slides</a>)</li>
   <li>Jedidiah McClurg, <i>The Multi-Principal OS Construction of the Gazelle Web Browser (by H. Wang, et al.)</i>, Northwestern EECS 450 Class Lecture, Evanston IL, USA, Apr 16, 2012<br/>
   (<a href="http://www.jrmcclurg.com/papers/talk_overview_gazelle_web_browser.pdf">slides</a>)</li>
   <li>Jedidiah McClurg, <i>Towards K-Nearest Neighbor Search in Time-Dependent Spatial Network Databases (by U. Demiryurek, et al.)</i>, Northwestern EECS 395 Computational Geometry Class, Evanston IL, USA, Nov 28, 2011<br/>
   (<a href="http://www.jrmcclurg.com/papers/talk_overview_knn.pdf">slides</a>)</li>
   <li>Jedidiah McClurg, <i>Proving Properties of Programs by Structural Induction (by R. M. Burstall)</i>, Northwestern EECS Systems Reading Group (SRG), Evanston IL, USA, Oct 25, 2011<br/>
   (<a href="http://www.jrmcclurg.com/papers/talk_overview_struct_induction.pdf">slides</a>)</li>
</ul>-->

<iframe src="https://www.google.com/calendar/embed?showCalendars=0&amp;mode=WEEK&amp;height=600&amp;wkst=1&amp;bgcolor=%23FFFFFF&amp;src=jj22f0vcsl40np3cc5fvq2dnvk%40group.calendar.google.com&amp;color=%23060D5E&amp;ctz=America%2FDenver" style=" border-width:0 " width="500" height="600" frameborder="0" scrolling="no"></iframe>
