<?php
   date_default_timezone_set("America/Denver");

   $tabs = array(
      "Home" => true,
      "Academic" => true,
      "Art" => true,
      "Blog" => false,
      "Literature" => false,
      "Music" => false,
      "About" => true
   );
   $tab = strtolower($_GET["page"]);

   if(!$tab) $tab = "academic";
   elseif($tab == "papers") $tab = "academic";

   $time = @filemtime($tab.".php");
   $time2 = filemtime("index.php");
   if(!$time || $time2 > $time) $time = $time2;

   header("Last-Modified: ".date("r", $time));
?>
<!DOCTYPE html 
     PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
   <head>
      <link rel="stylesheet" type="text/css" href="/style_main.css" />    
      <link rel="shortcut icon" href="/icon.ico" />
      <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
      <meta http-equiv="Content-Language" content="en" />
      <meta name="author" content="Jedidiah McClurg" />
      <meta name="copyright" content="&copy; 2010 Jedidiah R. McClurg" />
      <meta name="keywords" content="jedidiah mcclurg, jed mcclurg, jedidiah, mcclurg, jed" />
      <meta name="description" content="The personal website of Jed McClurg" />
      <title>Jedidiah R. McClurg</title>
   </head>
   <body>
      <table border="0" cellpadding="0" cellspacing="0" width="100%">
         <tr>
            <td align="center">
               <table border="0" cellpadding="0" cellspacing="0" class="page" width="500">
                  <tr>
                     <td class="header" align="center">
                        <table><tr><td><h1 class="title">Jedidiah R. McClurg</h1></td></tr></table>
                     </td>
                  </tr>
                  <tr>
                     <td class="divider"><hr class="divider" /></td>
                  </tr>
                  <tr>
                     <td>
                        <table border="0" cellpadding="0" cellspacing="0" width="100%">
                           <tr>
                              <?php
                                 foreach($tabs as $s => $enabl) {
                                    $t = (strtolower($s) == $tab);
                                    $href = "/".strtolower($s)."/";
                                    $begin_tag = $enabl ? "a href=\"".$href."\"" : "span";
                                    $end_tag = $enabl ? "</a>" : "</span>";
                                    $colr = $enabl ? "orange" : "lightgray";
                              ?> 
                              <td class="tab_unselected"></td>
                              <td class="tab_<?= $t ? "" : "un" ?>selected"><<?= $begin_tag ?> class="tab" onmouseover="this.style.background='<?= $colr ?>'; return true;" onmouseout="this.style.background='white'; return true;"><?= $s ?><?= $end_tag ?></td>
                              <!--<td class="tab_<?= $t ? "" : "un" ?>selected"><a href="http://www.jrmcclurg.com/<?= strtolower($s) ?>/" class="tab" onmouseover="this.style.background='orange'; return true;" onmouseout="this.style.background='white'; return true;"><?= $s ?></a></td>-->
                              <?php } ?> 
                              <td class="tab_unselected"></td>
                           </tr>
                        </table>
                     </td>
                  </tr>
                  <tr>
                     <td>
                        <table class="content" width="100%">
                           <tr><td><!--
                           <?php for($i = 0; $i < 20; $i++) { printf("%s. ", ucfirst($tab)); } ?>
                           The quick brown fox jumped over the lazy dog.
                           The quick brown fox jumped over the lazy dog.
                           The quick brown fox jumped over the lazy dog.
                           The quick brown fox jumped over the lazy dog.
                           The quick brown fox jumped over the lazy dog.
                           The quick brown fox jumped over the lazy dog.
                           The quick brown fox jumped over the lazy dog.
                           The quick brown fox jumped over the lazy dog.
                           The quick brown fox jumped over the lazy dog.
                           The quick brown fox jumped over the lazy dog.
                           The quick brown fox jumped over the lazy dog.-->
                           <?php
                              $command = strtolower($tab).".php";
                              @include($command);
                           ?>
                           </td></tr>
                        </table>
                     </td>
                  </tr>
               </table>
            </td>
         </tr>
         <tr>
            <td class="footer">Copyright &copy; <?= date("Y") ?> Jedidiah R. McClurg</td>
         </tr>
         <tr>
            <td class="footer">
               <a href="http://www.php.net/"><img alt="Powered by PHP" src="/php-power-white.png" width="57" height="20" /></a>
    <a href="http://validator.w3.org/check?uri=referer"><img
        width="57"
        height="20"
        src="/valid-xhtml10-blue.png"
        alt="Valid XHTML 1.0 Strict" /></a>
<a href="http://jigsaw.w3.org/css-validator/check/referer">
    <img 
        src="/valid-css2-blue.png"
        width="57"
        height="20"
        alt="Valid CSS!" />
</a>
            </td>
         </tr>
      </table>
   </body>
</html>
